# Annotation server setup
This repo contains all the code related to the generation of the dataset for the NeuroANN project.

```duckduckgo_scraper```: contains the code for the DuckDuckGo image scraper.

```server```: contains the code relating to the CherryPy server used for phase 1 annotations. These are the annotations
that are used to train a CNN that can distinguish between 'good' and 'bad' images, i.e., images that are or aren't
useful to us. In other words, these are NOT the annotations containing the emotion labels.

```www```: the www code that to be used together with the CherryPy server.

## Setting up the server
You will need a webserver to host the files contained in ```www```. We chose to go with Apache2. Assuming you are
working with Ubuntu, Apache2 can be installed using

```
sudo apt-get install apache2
```

The configuration of the Apache2 server can (by default) be found under ```/etc/apache2```. We need the
```filter.load```, ```proxy.load``` and ```proxy_http.load``` filters. To enable these, you need to copy them from
```/etc/apache2/mods-available``` to ```/etc/apache2/mods-enabled```. Once this is done, we need to update the
site configuration file ```/etc/apache2/sites-enabled/000-default.conf```. Add the following lines right before the
```</VirtualHost>``` tag:

```
ProxyPreserveHost On
ProxyRequests Off
ProxyPass /neuro3/api-phd/ http://localhost:8083/
ProxyPassReverse /neuro3/api-phd/ http://localhost:8083/
```

If you would rather use different port, you can change this in ```server_prolific/server_core.py```, line 36.

Copy the contents of ```server_prolific/www``` to a ```neuro3``` folder within the location from which Apache will
serve files. By default, this is ```/var/www/html/```, so you would copy the files to ```/var/www/html/neuro3```. 

To start the server, use the following command line:

```
sudo systemctl start apache2
```
Once the Apache2 server is running, start the CherryPy server by running the ```server_prolific/server_core.py``` script. 

## Loging into the server
To be able to annotate images using the web interface, one is required to be logged in. This is simply done by surfing
to ```http://localhost/neuro3/login.html?PROLIFIC_ID=xxx```, where ```xxx``` should be replaced by a username. If the
username is not already known, a new entry will be created in the encrypted user database.

The server-side logic is contained in ```server/login_api.py```. For encoding purposes, we use the 
[```cryptography```](https://cryptography.io/en/latest/) Python package.

The database of known users is stored in an encrypted csv file. The path to this file is specified in the ```Config```
class. By default, the encrypted file is named ```user_db.csv.enc```, and it is encrypted using the Fernet algorithm.
This algorithm makes use of a key, which is stored in a local file. Without this file, the user database can not be
decrypted. The default path to the file is specified in ```Config.FILE_FERNET_KEY```. If the file does not yet exist,
it will be created. (In other words, this should only happen once during development.) If it does not exist yet, a new
empty database will be created. When a new user is created, it will be appended to the database (i.e., DataFrame),
which will immediately be saved to disk, updating the already existing database file.

Each time the user database is needed, it is read from the disk. It is not stored into memory.

## JSON Web Token
The next piece in the authentication puzzle is verifying that a user is still logged in. On the
client-side, that state of being logged in is reflected in the presence of a [JSON Web Token](https://jwt.io/) or JWT.
These tokens however are generated by the server using the [PyJWT](https://pyjwt.readthedocs.io/en/latest/) Python
library. We encrypt the generated tokens by using a private/public key scheme using the RSA256 algorithm (standard
implementation in PyJWT). The used key pair is generated using ```ssh-keygen```. The client never needs to decode the
JWT, only the server needs to do so. Hence, the public key for this purpose can/should also be kept private. Just
generate a key pair, and place the files under the folder referred to by ```Config.DIR_AUTH```. A key pair has already
been provided for demo purposes, but should of course be replaced by a new one.

The JWTs have a limited lifetime. By default, they remain valid for 20 minutes from the user's last interaction with
the server. In other words, a user becomes effectively logged out after 20 minutes of inactivity.

The client-side logic is (mostly) contained in ```www/js/login.js```. This script contains the public key for the
encryption. As stated earlier, ```JSEncrypt``` is used to handle RSA encryption.

JWT tokens are stored in ```localStorage```. When a user logs out, the JWT is deleted. Otherwise, it will be kept, but
will expire.
